//IT17043342 Gunasinghe M.D.
package scit.shapesclassification;

import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.drawerlayout.widget.DrawerLayout;

import java.util.ArrayList;

public class MatchShapes extends AppCompatActivity {
    public TableLayout t1;
    public TableRow tr1;
    public TableRow tr2;
    public TableRow tr3;
    public TableRow tr4;
    public RelativeLayout r1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_match_shapes);

        t1 = findViewById(R.id.tableLayout1);
        tr1 = (TableRow) findViewById(R.id.tableRow1);
        tr2 = (TableRow) findViewById(R.id.tableRow2);
        tr3 = (TableRow) findViewById(R.id.tableRow3);
        tr4 = (TableRow) findViewById(R.id.tableRow4);
        r1 = findViewById(R.id.RelativeLayout2);


        Button btnRedo = findViewById(R.id.btnRedo);

        btnRedo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                recreate();
            }
        });

    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);

        RelativeLayout rl = findViewById(R.id.RelativeLayout2);
        DrawPanel drawingPanel = new DrawPanel(getApplicationContext());
        drawingPanel.setLayoutParams(new DrawerLayout.LayoutParams(rl.getWidth(), rl.getHeight()));
        rl.addView(drawingPanel);

    }


    public class DrawPanel extends View {
        private Paint paint;
        int ans = 0;
        String temp1 = "";
        String temp2 = "";

        private ArrayList<Point> points;

        private ArrayList<ArrayList<Point>> strokes;

        public DrawPanel(Context context) {
            super(context);

            points = new ArrayList<>();
            strokes = new ArrayList<>();
            paint = createPaint();

        }

        @Override
        public void onDraw(Canvas c) {
            super.onDraw(c);

            for (ArrayList<Point> obj : strokes) {
                drawStroke(obj, c);
            }

            drawStroke(points, c);

        }

        public void clearCanvas(){

            invalidate();
        }


        @Override
        public boolean onTouchEvent(MotionEvent event) {


            if (event.getActionMasked() == MotionEvent.ACTION_MOVE) {
                points.add(new Point((int) event.getX(), (int) event.getY()));
                if (temp1.equals("")) {
                    temp1 = getColor((int) event.getX(), (int) event.getY());
                }
                System.out.println("[start] " + temp1);

                invalidate();
            }

            if (event.getActionMasked() == MotionEvent.ACTION_UP) {

                temp2 = getColor((int) event.getX(), (int) event.getY());
                System.out.println("[end] " + temp2);
                if (temp1.equals(temp2) && !temp1.equals("")) {
                        ans++;
                    LayoutInflater inflater = getLayoutInflater();
                    View toastLayout = inflater.inflate(R.layout.custom_toast1,(ViewGroup)findViewById(R.id.toast_root));
                    Toast toast = new Toast(getApplicationContext());
                    toast.setDuration(Toast.LENGTH_SHORT);
                    toast.setView(toastLayout);
                    toast.show();//correct answer
                } else {
                    LayoutInflater inflater = getLayoutInflater();
                    View toastLayout = inflater.inflate(R.layout.custom_toast2,(ViewGroup)findViewById(R.id.toast_root2));
                    Toast toast = new Toast(getApplicationContext());
                    toast.setDuration(Toast.LENGTH_SHORT);
                    toast.setView(toastLayout);
                    toast.show();//incorrect answer
                }

                temp1 = "";
                temp2 = "";

                this.strokes.add(points);
                points = new ArrayList<>();
                invalidate();

            }

            return true;
        }

        public String getColor(int x, int y) {
            for (int r = 0; r < t1.getChildCount(); r++) {
                int y0 = (int) t1.getChildAt(r).getY();
                int height = y0 + t1.getChildAt(r).getHeight();

                if (y >= y0 && y < height) {

                    for (int i = 0; i < 3; i += 2) {
                        int x1 = (int) tr1.getChildAt(i).getX() - 50;
                        int width = x1 + tr1.getChildAt(i).getWidth() + 50;
                        if (x >= x1 && x < width) {

                            return (String) (((TableRow) t1
                                    .getChildAt(r))
                                    .getChildAt(i)).getTag();
                        }
                    }
                }
            }
            return "";
        }

        private void drawStroke(ArrayList<Point> stroke, Canvas c) {
            if (stroke.size() > 0) {
                Point p0 = stroke.get(0);
                for (int i = 1; i < stroke.size(); i++) {
                    Point p1 = stroke.get(i);
                    c.drawLine(p0.x, p0.y, p1.x, p1.y, paint);
                    p0 = p1;

                }
            }
        }

        private Paint createPaint() {
            Paint temp = new Paint();
            temp.setStyle(Paint.Style.STROKE);
            temp.setAntiAlias(true);
            temp.setColor(Color.BLACK);
            temp.setStrokeWidth((float) 11);
            temp.setStrokeCap(Paint.Cap.ROUND);

            return temp;
        }
    }
}
